--
-- VHDL course - Practical Phase III - Autumn 2002
--
-- Group 3: 
--  Jouni Osmala <josmala@cc.hut.fi>
--  Ilpo Jrvinen <ilpo.jarvinen@helsinki.fi>
--

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity multadd is 
  generic (
    input_size : integer := 6;
    output_size : integer := 19);
  port ( 
    a : in std_logic_vector(input_size-1 downto 0);
    b : in std_logic_vector(input_size-1 downto 0);
    c : in std_logic_vector(output_size-1 downto 0);
    r : out std_logic_vector(output_size-1 downto 0));
end multadd;


architecture silenced of multadd is
begin

  -- purpose: r <= a^2+b^2+c
  --
  -- inputs: a, b, c
  -- outputs: r
  process (a, b, c) is
    variable m, n : integer range -32 to 31;
  begin
    r <= (others => '0');
    -- If is used to remove warnings from 'Z' states
    if c(0) = '1' or c(0) = '0' then
      m := conv_integer(signed(a));
      n := conv_integer(signed(b));
      r <= m ** 2 + n ** 2 + unsigned(c);
    end if;
  end process;
end;

-- CHECKME, how does the configurations work...
-- This remains disabled until then.
--architecture simple of multadd is
--begin
--   r <= conv_std_logic_vector(
--         conv_integer(signed(a)) * conv_integer(signed(a))
--       + conv_integer(signed(b)) * conv_integer(signed(b))
--       + conv_integer(signed(c)),output_size);
--
--end;
