--
-- VHDL course - Practical Phase III - Autumn 2002
--
-- Group 3: 
--  Jouni Osmala <josmala@cc.hut.fi>
--  Ilpo Jrvinen <ilpo.jarvinen@helsinki.fi>
--
-- Stolen from VHDL course Practical package.
--

LIBRARY ieee;
USE ieee.std_logic_1164.ALL;

ENTITY mux_2_to_1 IS
  
  GENERIC (
    bits : integer := 1);               -- Number of signal bits

  PORT (
    d0 : IN  std_logic_vector(bits-1 DOWNTO 0);   -- Data input 0
    d1 : IN  std_logic_vector(bits-1 DOWNTO 0);   -- Data input 1
    s : IN  std_logic;                           -- Select
    q : OUT std_logic_vector(bits-1 DOWNTO 0));  -- Data out

END mux_2_to_1;

ARCHITECTURE behave OF mux_2_to_1 IS

BEGIN  -- behave

  -- purpose: The output data is either the input d0 or d1
  --          according to the select signal s.
  --          If s = '0', q <= d0
  --          Elsif s = '1', q <= d1 
  -- type   : combinational
  -- inputs : s, d0, d1
  -- outputs: q
  mux: PROCESS (s, d0, d1)
  BEGIN  -- PROCESS mux
    CASE s IS
      WHEN '0' =>
        q <= d0;
      WHEN '1' =>
        q <= d1;
      WHEN OTHERS => NULL;
    END CASE;
  END PROCESS mux;

END behave;


