--
-- VHDL course - Practical Phase III - Autumn 2002
--
-- Group 3: 
--  Jouni Osmala <josmala@cc.hut.fi>
--  Ilpo Jrvinen <ilpo.jarvinen@helsinki.fi>
--

--
-- Basic 32-bit LCG PRNG.
--
-- Source: http://www.science.gmu.edu/~egodard/prgasm1/lcg.html
--

package random is
	constant a : integer := 16807;
	constant m : integer := 2147483647;
	
	shared variable seed_val : integer;
	
	procedure srand( seed : integer );
	impure function rand return integer;
end package random;
	
package body random is
	
	procedure srand( seed : integer ) is
	begin
		seed_val := seed;
	end procedure;
	
	impure function rand return integer is
		variable temp : integer;
	begin
		temp := (seed_val * a) mod m;
		random.seed_val := temp;
		return temp;
	end function;
end random;