--
-- VHDL course - Practical Phase III - Autumn 2002
--
-- Group 3:
--  Jouni Osmala <josmala@cc.hut.fi>
--  Ilpo Jrvinen <ilpo.jarvinen@helsinki.fi>
--

library ieee;
use ieee.std_logic_1164.all;

entity tristate_buffer is
  generic (
    bits : integer := 1);			   -- Width of the data.
  port (
    ena  : in  std_logic;                          -- dout driven?
    din  : in  std_logic_vector(bits-1 downto 0);  -- data input
    dout : out std_logic_vector(bits-1 downto 0)); -- data output to bus

end tristate_buffer;

architecture behave of tristate_buffer is
begin

  dout <= din when ena = '1' else    -- We are driving the bus.
          (others => 'Z');           -- High-impedance.
          
end behave;

